package vstone.app.BTSample;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.Queue;
import java.util.regex.*;

import vstone.app.BTSample.R;

import android.preference.PreferenceManager;

import android.R.bool;
import android.R.integer;
import android.R.string;
import android.app.Activity;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.content.ActivityNotFoundException;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.SharedPreferences.Editor;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.preference.Preference;
import android.preference.PreferenceManager;
import android.speech.RecognizerIntent;
import android.util.Log;
import android.view.Gravity;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.Window;
import android.view.View.OnClickListener;
import android.view.inputmethod.EditorInfo;
import android.view.GestureDetector;
import android.view.GestureDetector.SimpleOnGestureListener;
import android.view.MotionEvent;
import android.view.WindowManager;
import android.view.Display;
import android.graphics.drawable.*;
import android.graphics.*;
import android.content.Context;

import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

import android.text.Layout.Alignment;

import java.io.*;

public class BluetoothSample extends Activity {
    // Debugging
    private static final String TAG = "BluetoothChat";
    private static final boolean D = true;

    //BluetoothChatService瑗Ă郁bZ[W̒`
    public static final int MESSAGE_STATE_CHANGE = 1;
    public static final int MESSAGE_READ = 2;
    public static final int MESSAGE_WRITE = 3;
    public static final int MESSAGE_DEVICE_NAME = 4;
    public static final int MESSAGE_TOAST = 5;

    //BluetoothChatServicefoCXAg[Xg\p󂯎邽߂̕ϐ
    public static final String DEVICE_NAME = "device_name";
    public static final String TOAST = "toast";

    // Intent request codes
    private static final int REQUEST_CONNECT_DEVICE = 1;
    private static final int REQUEST_ENABLE_BT = 2;

    //ڑĂfoCX
    private String mConnectedDeviceName = null;
    
    // Local Bluetooth adapter
    private BluetoothAdapter mBluetoothAdapter = null;
    // Member object for the chat services
    private BluetoothChatService mChatService = null;
    
	public static final String PREFS_NAME = "BluetoothPadConfig";

	public Queue<String> RcvStrFifo = new LinkedList<String>();

	static boolean servo_pwr = false;
	TextView textview;
	
	Toast mytoast = null;
	
/********************
 * Activity̏
 * ȉ̏ŋNAI
 @@		@X^[g
	        v
	    onCreate()
	        v
	    onStart()
	        v
	    onResume()
	        v
		s
	        v
	    onPause()
	        v
	    onStop()
	        v
	    onDestroy()
	        v
		Vbg_E
*/
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        Log.d(TAG, "onCreate");
        setContentView(R.layout.main);

        //Bluetooth A_v^̎擾
        mBluetoothAdapter = BluetoothAdapter.getDefaultAdapter();

        // X}[gtHŃA_v^ȂAT|[gĂȂAI
        if (mBluetoothAdapter == null) {
        	ShowToast(this, "Bluetooth is not available", Toast.LENGTH_LONG);
        	
            finish();
            return;
        }
        //\peLXgr[擾
		textview = (TextView)findViewById(R.id.TextView_vat);
        
        Button button = (Button) findViewById(R.id.Button_ONOFF);
        // {^NbNꂽɌĂяoR[obNXi[o^
        button.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
            	if(servo_pwr)
            		servo_pwr = false;
            	else 
            		servo_pwr = true;
            	SendVSRC_Pwr(servo_pwr);
            }
        });

        //{^̏
        button = (Button) findViewById(R.id.Button_o);
        // {^NbNꂽɌĂяoR[obNXi[o^
        button.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
            	SendVSRC_PadCmd(32,0,0,0,0);
            	textview.setText("𑗐M");
            }
        });
        
        //{^̏
        button = (Button) findViewById(R.id.Button_up);
        // {^NbNꂽɌĂяoR[obNXi[o^
        button.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
            	SendVSRC_PadCmd(4096,0,0,0,0);
            	textview.setText("𑗐M");
            }
        });
        
        //clear{^̏
        button = (Button) findViewById(R.id.Button_clear);
        // {^NbNꂽɌĂяoR[obNXi[o^
        button.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
            	SendVSRC_PadCmd(0,0,0,0,0);
            	textview.setText("𑗐M");
            }
        });
        
        //ǂݍ݃{^̏
        button = (Button) findViewById(R.id.Button_read);
        // {^NbNꂽɌĂяoR[obNXi[o^
        button.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
            	String rcvstr = ReadMemmap(239);
            	if(!rcvstr.equals("ERROR")){
            		textview.setText(rcvstr + "mV");
            	}
            	else{
            		textview.setText("ERROR");
            	}
            }
        });
        
    }

    @Override
    public void onStart() {
        super.onStart();
		Log.d("BluetoothChat","onStart");

        //BluetoothLɂ
        if (!mBluetoothAdapter.isEnabled()) {
            Intent enableIntent = new Intent(BluetoothAdapter.ACTION_REQUEST_ENABLE);
            startActivityForResult(enableIntent, REQUEST_ENABLE_BT);
        } else {
            if (mChatService == null){
                mChatService = new BluetoothChatService(this, mHandler);
                mChatService.parent = this;
            }
        }
        
		Log.d("BluetoothChat","onStart End");
    }

    @Override
    public synchronized void onResume() {
        super.onResume();
		Log.d("BluetoothChat","onResume");
        if (mChatService != null) {
            if (mChatService.getState() == BluetoothChatService.STATE_NONE) {
            	mChatService.start();
            }
        }
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        if (mChatService != null) mChatService.stop();
        Log.d(TAG, "onDestroy");
    }

/***********************************
* VS-RCʐM֘A
***********************************/    

//VS-RC̑cJnAT[{ON,OFFؑ֗p
    private void SendVSRC_Pwr(boolean pwr){
        String message;
    	if(pwr){			
	    	message = new String("w 2009e0 00 00\r\n");
            sendMessage(message);
            try{
                Thread.sleep(100);
            }catch (Exception e) {
    			// TODO: handle exception
    		}
            message = new String("w 2009f6 00 00\r\n");
            sendMessage(message);
            
	        Log.d("sendPadCmdRunble", "Powew On ");
		}
		else{
	    	message = new String("w 2009e0 00 00\r\n");
            sendMessage(message); 
            try{
                Thread.sleep(100);
            }catch (Exception e) {
    			// TODO: handle exception
    		}
            message = new String("w 2009f6 01 00\r\n");
            sendMessage(message);
            
	        Log.d("sendPadCmdRunble", "Powew Off ");
		}
    }
    

/* VS-RCւ̃R}hMp
 *  
 * 				b15|b14|b13|b12|b11 |b10|b9 |b8  	|b7|b6|b5|b4|b3|b2|b1| b0
 * pad_btnF		  |  | E | ||R3 |L3 |ڸ	| |~ | | |R1|L1|R2|L2
 * An_R_xF		:-127,S:0,E:+127
 * An_R_yF		:-127,S:0,:+127
 * An_L_xF		:-127,S:0,E:+127
 * An_L_yF		:-127,S:0,:+127
*/
    private boolean SendVSRC_PadCmd(int pad_btn
    							,int An_R_x,int An_R_y
    							,int An_L_x,int An_L_y){
        String message;
        message = new String("w 2009e2 " 
        		+ getCmdHexString(pad_btn) + " "	//241
        		+ getCmdHexString(0)	 + " "		//242
        		+ getCmdHexString(0)	 + " "		//243
        		+ getCmdHexString(An_R_x) + " "		//244
        		+ getCmdHexString(An_R_y) + " "		//245
        		+ getCmdHexString(An_L_x) + " "		//246
        		+ getCmdHexString(An_L_y) + " "		//247
        		+"\r\n");
        return sendMessage(message);
    }
    
//VS-RCւ̑MpɁAl𕶎ɕϊ
    private String getCmdHexString(int hex_value){
    	StringBuffer str_buf = new StringBuffer(Integer.toHexString(hex_value));
    	while(str_buf.length() < 4){
    		str_buf.insert(0, "0"); 
    	}
    	while(str_buf.length() > 4){
    		str_buf.delete(0,1);	    		
    	}
    	
    	String ret = str_buf.substring(2, 4) + " " + str_buf.substring(0, 2);
    	return ret;
    }
    
    private int valueofCmd(String rcvstr){
    	rcvstr.replaceAll(" ","");
    	rcvstr.replaceAll("#","");
   	
    	if(rcvstr.length() >= 4){
        	StringBuffer str_buf = new StringBuffer(rcvstr);
        	String str = str_buf.charAt(2) + str_buf.charAt(3)	+ " "
    					+ str_buf.charAt(0) + str_buf.charAt(1) + " ";
        	return HexToInt(str);
    	}
    	else
    		return 0;
    }
    
// PUi𐔒l 
    private int HexToInt(String str) {
        char s[];
        int r;
        r = 0;        
       s = str.toCharArray(); // z
       
       for (int i = 0 ; i < str.length() ; i++) { /* ꎚÂo */
    	   if(s[i] >'0' && s[i] <= '9'){
    		   r += s[i] - '0';
    	   }
    	   else if(s[i] >'A' && s[i] <= 'F'){
    		   r += s[i] - 'A' + 10;
    	   }
    	   else if(s[i] >'a' && s[i] <= 'f'){
    		   r += s[i] - 'a' + 10;
    	   }
    	   if(i + 1 < str.length())
    		   r *= 16;
        }
        return r; /* ʂ̐lԂ */
    }
    
//}bv֒l
    private boolean WriteMemmap(int addr , int value){
		long realaddr = 0x200800;
		realaddr += (long)addr*2;
		
		String sendstr = "w ";
		sendstr += Long.toHexString(realaddr);
		sendstr += " ";
		sendstr += getCmdHexString(value);
		sendstr += "\r\n";
		
		return sendMessage(sendstr);
	}

//}bvl擾@Ml̕Ԃ
    private String ReadMemmap(int addr){
		long realaddr = 0x200800;
		realaddr += (long)addr*2;
		
		clearRcvfifo();
		
		String sendstr = "r ";
		sendstr += Long.toHexString(realaddr);
		sendstr += " ";
		sendstr += " 02\r\n";
		if(!sendMessage(sendstr))
			return "ERROR";

        Log.d(TAG, "ReadMemmap sendMessage");
		int timeout = 100;
		while(RcvStrFifo.size() < 2){
			try{
				Thread.sleep(10);
				timeout--;
			}catch (Exception e) {
				// TODO: handle exception
			}
			if(timeout < 0){
		        Log.d(TAG, "ReadMemmap ERROR");
				return "ERROR";
			}
		}
		String rcv = RcvStrFifo.poll();
		rcv = RcvStrFifo.poll();
		rcv = rcv.replaceAll(Long.toHexString(realaddr),"");
		rcv = rcv.replaceAll("#","");
		rcv = rcv.replaceFirst(" ","");
		
		String[] strAry = rcv.split(" ");		
		int value = HexToInt(strAry[1]) * 256
						+ HexToInt(strAry[0]);
		
		return String.valueOf(value);
	}
    


/***********************************
 * Bluetooth֘A
 ***********************************/
//foCX̌
    private void ensureDiscoverable() {
        Log.d(TAG, "ensureDiscoverable");
        if (mBluetoothAdapter.getScanMode() !=
            BluetoothAdapter.SCAN_MODE_CONNECTABLE_DISCOVERABLE) {
            Intent discoverableIntent = new Intent(BluetoothAdapter.ACTION_REQUEST_DISCOVERABLE);
            //300secŃ^CAEgɂ
            discoverableIntent.putExtra(BluetoothAdapter.EXTRA_DISCOVERABLE_DURATION, 300);
            startActivity(discoverableIntent);
        }
    }

//BluetoothŃbZ[W𑗐M   
    private boolean sendMessage(String message) {
        Log.d(TAG, "sendMessage");
        
    	//BluetoothChatServiceNĂȂABluetoothChatServiceȂꍇ͑MȂ
        if (mChatService != null){
	        if (mChatService.getState() != BluetoothChatService.STATE_CONNECTED) {
	        	ShowToast(getApplicationContext()
                				, getString(R.string.not_connected)
                				, Toast.LENGTH_SHORT);
                	        	
	            return false;
	        }
        }
        else
        	return false;

        //bZ[W̒0ȏゾA
        if (message.length() > 0) {
        	
            byte[] send = message.getBytes();
            mChatService.write(send);

            Log.d(TAG, "sendMessage write ok");
        }
        return true;
    }
    
    private void clearRcvfifo(){
		while(RcvStrFifo.size() > 0){
			RcvStrFifo.poll();
		}
		rcvstr = new StringBuffer("");		
	}

    StringBuffer rcvstr = new StringBuffer();
//BluetoothChatServicẽbZ[WMs
    private final Handler mHandler = new Handler() {
        @Override
        public void handleMessage(Message msg) {
            Log.d(TAG, "handleMessage");
            switch (msg.what) {
            case MESSAGE_STATE_CHANGE:
                if(D) Log.i(TAG, "MESSAGE_STATE_CHANGE: " + msg.arg1);
                switch (msg.arg1) {
                case BluetoothChatService.STATE_CONNECTED:
                	
                	ShowToast(getApplicationContext()
                    				, getString(R.string.title_connected_to)
                    				, Toast.LENGTH_SHORT);
                    	        	  

                    break;
                case BluetoothChatService.STATE_CONNECTING:                	
                	ShowToast(getApplicationContext()
            				, getString(R.string.title_connecting)
            				, Toast.LENGTH_SHORT);
            	        	
                    break;
                case BluetoothChatService.STATE_LISTEN:
                case BluetoothChatService.STATE_NONE:
                	ShowToast(getApplicationContext()
            				, getString(R.string.title_not_connected)
            				, Toast.LENGTH_SHORT);
                    break;
                }
                break;
            case MESSAGE_WRITE:
            {
                byte[] writeBuf = (byte[]) msg.obj;
                int size = msg.arg1;
            }
                break;
            case MESSAGE_READ:
            {
                byte[] readBuf = (byte[]) msg.obj;
                int size = msg.arg1;
            }
                break;
            case MESSAGE_DEVICE_NAME:
                mConnectedDeviceName = msg.getData().getString(DEVICE_NAME);
                
                ShowToast(getApplicationContext(), "Connected to "
                               + mConnectedDeviceName, Toast.LENGTH_SHORT);
                           	
                break;
            case MESSAGE_TOAST:
            	
            	ShowToast(getApplicationContext(), msg.getData().getString(TOAST),
                               Toast.LENGTH_SHORT);
                           	
                break;
            }
        }
    };
    
    public void SetReadBuffer(byte[] readBuf,int length){
        String readstr = new String(readBuf, 0, length);
        rcvstr.append(readstr);

        Log.d(TAG, "SetReadBuffer " + rcvstr);
        
        while(true){
        	int num = rcvstr.indexOf("\n");
            if(num >= 0){
            	readstr = rcvstr.substring(0,num+1);
            	readstr.replaceAll("\n","");
            	readstr.replaceAll("\r","");
            	rcvstr = new StringBuffer(rcvstr.substring(num+1));  
            	
                RcvStrFifo.offer(readstr);
                Log.d(TAG, "SetReadBuffer RcvStrFifo" + readstr);
            }
            else
            	break;
        }
    }
    
//Activity̖߂菈
    @Override
    public void onActivityResult(int requestCode, int resultCode, Intent data) {
        if(D) Log.d(TAG, "onActivityResult " + resultCode);
        switch (requestCode) {
        
        case REQUEST_CONNECT_DEVICE:
            // When DeviceListActivity returns with a device to connect
            if (resultCode == Activity.RESULT_OK) {
                // Get the device MAC address
                String address = data.getExtras()
                                     .getString(DeviceListActivity.EXTRA_DEVICE_ADDRESS);
                // Get the BLuetoothDevice object
                BluetoothDevice device = mBluetoothAdapter.getRemoteDevice(address);
                // Attempt to connect to the device
                mChatService.connect(device);
            }
            break;
            
        case REQUEST_ENABLE_BT:
        	if (resultCode == Activity.RESULT_OK) {
                //BluetoothLɂȂABluetoothChatServiceJn
                mChatService = new BluetoothChatService(this, mHandler);   
                mChatService.parent = this;
            } else {
            	//LɂłȂAI
                Log.d(TAG, "BT not enabled");                
                ShowToast(getApplicationContext()
        				, getString(R.string.bt_not_enabled_leaving)
        				, Toast.LENGTH_SHORT);
        	        	
                finish();
            }
            break;
        }
    }
    

/***********************************
* IvVj[֘A
***********************************/    

//IvVj[̏
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.option_menu, menu);
        return true;
    }

//IvVj[Ȉ
    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
    	Log.d("onOptionsItemSelected","in");
        switch (item.getItemId()) {
        case R.id.scan:        	
            Intent serverIntent = new Intent(this, DeviceListActivity.class);
            startActivityForResult(serverIntent, REQUEST_CONNECT_DEVICE);
            return true;
            
        case R.id.discoverable:
            ensureDiscoverable();
            return true;
        }
        return false;
    }
    
    
    public void ShowToast(Context context, CharSequence text, int duration) {
    	if(mytoast != null){
    		mytoast.cancel();
    	}
    	mytoast = Toast.makeText(context, text, duration);
    	mytoast.show();
	} 
}